import{s as Ge,o as Me,n as ke}from"../chunks/scheduler.d6170356.js";import{S as Ce,i as Pe,g as s,s as l,r as g,A as Le,h as a,f as i,c as o,j as Te,u as f,x as r,k as qt,y as He,a as n,v as c,d,t as h,w as y,m as be,n as xe}from"../chunks/index.fcd4cc08.js";import{T as _e}from"../chunks/Tip.b09c67cf.js";import{C as Nt}from"../chunks/CodeBlock.7b16bdef.js";import{H as ot,E as Ee}from"../chunks/EditOnGithub.da2b595c.js";function Ue(st){let m,p,v="git config --global commit.gpgsign true",$;return{c(){m=be("To sign all commits by default in any local repository on your computer, you can run "),p=s("code"),p.textContent=v,$=be(".")},l(u){m=xe(u,"To sign all commits by default in any local repository on your computer, you can run "),p=a(u,"CODE",{"data-svelte-h":!0}),r(p)!=="svelte-1je77r9"&&(p.textContent=v),$=xe(u,".")},m(u,w){n(u,m,w),n(u,p,w),n(u,$,w)},p:ke,d(u){u&&(i(m),i(p),i($))}}}function Se(st){let m,p,v,$,u,w,G,zt="<code>git</code> has an authentication layer to control who can push commits to a repo, but it does not authenticate the actual commit authors.",at,M,Qt="In other words, you can commit changes as <code>Elon Musk &lt;elon@tesla.com&gt;</code>, push them to your preferred <code>git</code> host (for instance github.com), and your commit will link to Elon’s GitHub profile. (Try it! But don’t blame us if Elon gets mad at you for impersonating him.)",rt,k,Vt="The reasons we implemented GPG signing were:",ut,C,Dt="<li>To provide finer-grained security, especially as more and more Enterprise users rely on the Hub.</li> <li>To provide ML benchmarks backed by a cryptographically-secure source.</li>",mt,P,Kt='See Ale Segala’s <a href="https://withblue.ink/2020/05/17/how-and-why-to-sign-git-commits.html" rel="nofollow">How (and why) to sign <code>git</code> commits</a> for more context.',pt,L,Xt="You can prove a commit was authored by you with GNU Privacy Guard (GPG) and a key server. GPG is a cryptographic tool used to verify the authenticity of a message’s origin. We’ll explain how to set this up on Hugging Face below.",gt,H,Rt='The Pro Git book is, as usual, a good resource about commit signing: <a href="https://git-scm.com/book/en/v2/Git-Tools-Signing-Your-Work" rel="nofollow">Pro Git: Signing your work</a>.',ft,_,ct,E,te='You will need to install <a href="https://gnupg.org/" rel="nofollow">GPG</a> on your system in order to execute the following commands.',dt,U,ee=`<p>It’s included by default in most Linux distributions.
On Windows, it is included in Git Bash (which comes with <code>git</code> for Windows).</p>`,ht,S,ie=`You can sign your commits locally using <a href="https://gnupg.org/" rel="nofollow">GPG</a>.
Then configure your profile to mark these commits as <strong>verified</strong> on the Hub,
so other people can be confident that they come from a trusted source.`,yt,I,ne='For a more in-depth explanation of how git and GPG interact, please visit the the <a href="https://git-scm.com/book/en/v2/Git-Tools-Signing-Your-Work" rel="nofollow">git documentation on the subject</a>',$t,J,le="Commits can have the following signing statuses:",vt,W,oe="<thead><tr><th>Status</th> <th>Explanation</th></tr></thead> <tbody><tr><td>Verified</td> <td>The commit is signed and the signature is verified</td></tr> <tr><td>Unverified</td> <td>The commit is signed but the signature could not be verified</td></tr> <tr><td>No signing status</td> <td>The commit is not signed</td></tr></tbody>",wt,Y,se="For a commit to be marked as <strong>verified</strong>, you need to upload the public key used to sign it on your Hugging Face account.",Tt,j,ae=`Use the <code>gpg --list-secret-keys</code> command to list the GPG keys for which you have both a public and private key.
A private key is required for signing commits or tags.`,bt,B,re="If you don’t have a GPG key pair or you don’t want to use the existing keys to sign your commits, go to <strong>Generating a new GPG key</strong>.",xt,F,ue='Otherwise, go straight to  <a href="#adding-a-gpg-key-to-your-account">Adding a GPG key to your account</a>.',Gt,A,Mt,O,me="To generate a GPG key, run the following:",kt,Z,Ct,q,pe="GPG will then guide you through the process of creating a GPG key pair.",Pt,N,ge='Make sure you specify an email address for this key, and that the email address matches the one you specified in your Hugging Face <a href="https://huggingface.co/settings/account" rel="nofollow">account</a>.',Lt,z,Ht,Q,fe='<li><p>First, select or generate a GPG key on your computer. Make sure the email address of the key matches the one in your Hugging Face <a href="https://huggingface.co/settings/account" rel="nofollow">account</a> and that the email of your account is verified.</p></li> <li><p>Export the public part of the selected key:</p></li>',_t,V,Et,T,ce='<li>Then visit your profile <a href="https://huggingface.co/settings/keys" rel="nofollow">settings page</a> and click on <strong>Add GPG Key</strong>.</li>',Ut,D,de="Copy &amp; paste the output of the <code>gpg --export</code> command in the text area and click on <strong>Add Key</strong>.",St,b,he="<li>Congratulations! 🎉  You’ve just added a GPG key to your account!</li>",It,K,Jt,X,ye="The last step is to configure git to sign your commits:",Wt,R,Yt,tt,$e="Then add the <code>-S</code> flag to your <code>git commit</code> commands to sign your commits!",jt,et,Bt,it,ve="Once pushed on the Hub, you should see the commit with a “Verified” badge.",Ft,x,At,nt,Ot,lt,Zt;return u=new ot({props:{title:"Signing commits with GPG",local:"signing-commits-with-gpg",headingTag:"h1"}}),_=new ot({props:{title:"Setting up signed commits verification",local:"setting-up-signed-commits-verification",headingTag:"h2"}}),A=new ot({props:{title:"Generating a new GPG key",local:"generating-a-new-gpg-key",headingTag:"h2"}}),Z=new Nt({props:{code:"Z3BnJTIwLS1nZW4ta2V5",highlighted:"gpg --gen-key",wrap:!1}}),z=new ot({props:{title:"Adding a GPG key to your account",local:"adding-a-gpg-key-to-your-account",headingTag:"h2"}}),V=new Nt({props:{code:"Z3BnJTIwLS1hcm1vciUyMC0tZXhwb3J0JTIwJTNDWU9VUiUyMEtFWSUyMElEJTNF",highlighted:'gpg --armor --<span class="hljs-built_in">export</span> &lt;YOUR KEY ID&gt;',wrap:!1}}),K=new ot({props:{title:"Configure git to sign your commits with GPG",local:"configure-git-to-sign-your-commits-with-gpg",headingTag:"h2"}}),R=new Nt({props:{code:"Z2l0JTIwY29uZmlnJTIwdXNlci5zaWduaW5na2V5JTIwJTNDWW91ciUyMEdQRyUyMEtleSUyMElEJTNFJTBBZ2l0JTIwY29uZmlnJTIwdXNlci5lbWFpbCUyMCUzQ1lvdXIlMjBlbWFpbCUyMG9uJTIwaGYuY28lM0U=",highlighted:`git config user.signingkey &lt;Your GPG Key ID&gt;
git config user.email &lt;Your email on hf.co&gt;`,wrap:!1}}),et=new Nt({props:{code:"Z2l0JTIwY29tbWl0JTIwLVMlMjAtbSUyMCUyMk15JTIwZmlyc3QlMjBzaWduZWQlMjBjb21taXQlMjI=",highlighted:'git commit -S -m <span class="hljs-string">&quot;My first signed commit&quot;</span>',wrap:!1}}),x=new _e({props:{$$slots:{default:[Ue]},$$scope:{ctx:st}}}),nt=new Ee({props:{source:"https://github.com/huggingface/hub-docs/blob/main/docs/hub/security-gpg.md"}}),{c(){m=s("meta"),p=l(),v=s("p"),$=l(),g(u.$$.fragment),w=l(),G=s("p"),G.innerHTML=zt,at=l(),M=s("p"),M.innerHTML=Qt,rt=l(),k=s("p"),k.textContent=Vt,ut=l(),C=s("ul"),C.innerHTML=Dt,mt=l(),P=s("p"),P.innerHTML=Kt,pt=l(),L=s("p"),L.textContent=Xt,gt=l(),H=s("p"),H.innerHTML=Rt,ft=l(),g(_.$$.fragment),ct=l(),E=s("p"),E.innerHTML=te,dt=l(),U=s("blockquote"),U.innerHTML=ee,ht=l(),S=s("p"),S.innerHTML=ie,yt=l(),I=s("p"),I.innerHTML=ne,$t=l(),J=s("p"),J.textContent=le,vt=l(),W=s("table"),W.innerHTML=oe,wt=l(),Y=s("p"),Y.innerHTML=se,Tt=l(),j=s("p"),j.innerHTML=ae,bt=l(),B=s("p"),B.innerHTML=re,xt=l(),F=s("p"),F.innerHTML=ue,Gt=l(),g(A.$$.fragment),Mt=l(),O=s("p"),O.textContent=me,kt=l(),g(Z.$$.fragment),Ct=l(),q=s("p"),q.textContent=pe,Pt=l(),N=s("p"),N.innerHTML=ge,Lt=l(),g(z.$$.fragment),Ht=l(),Q=s("ol"),Q.innerHTML=fe,_t=l(),g(V.$$.fragment),Et=l(),T=s("ol"),T.innerHTML=ce,Ut=l(),D=s("p"),D.innerHTML=de,St=l(),b=s("ol"),b.innerHTML=he,It=l(),g(K.$$.fragment),Jt=l(),X=s("p"),X.textContent=ye,Wt=l(),g(R.$$.fragment),Yt=l(),tt=s("p"),tt.innerHTML=$e,jt=l(),g(et.$$.fragment),Bt=l(),it=s("p"),it.textContent=ve,Ft=l(),g(x.$$.fragment),At=l(),g(nt.$$.fragment),Ot=l(),lt=s("p"),this.h()},l(t){const e=Le("svelte-u9bgzb",document.head);m=a(e,"META",{name:!0,content:!0}),e.forEach(i),p=o(t),v=a(t,"P",{}),Te(v).forEach(i),$=o(t),f(u.$$.fragment,t),w=o(t),G=a(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-16xioii"&&(G.innerHTML=zt),at=o(t),M=a(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1496un1"&&(M.innerHTML=Qt),rt=o(t),k=a(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-iec5lg"&&(k.textContent=Vt),ut=o(t),C=a(t,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-1ruuqle"&&(C.innerHTML=Dt),mt=o(t),P=a(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-y864g7"&&(P.innerHTML=Kt),pt=o(t),L=a(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-n96a7q"&&(L.textContent=Xt),gt=o(t),H=a(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-138n0c9"&&(H.innerHTML=Rt),ft=o(t),f(_.$$.fragment,t),ct=o(t),E=a(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1p8rrlz"&&(E.innerHTML=te),dt=o(t),U=a(t,"BLOCKQUOTE",{"data-svelte-h":!0}),r(U)!=="svelte-osktdt"&&(U.innerHTML=ee),ht=o(t),S=a(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-6aimav"&&(S.innerHTML=ie),yt=o(t),I=a(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-10krbex"&&(I.innerHTML=ne),$t=o(t),J=a(t,"P",{"data-svelte-h":!0}),r(J)!=="svelte-b4b7dr"&&(J.textContent=le),vt=o(t),W=a(t,"TABLE",{"data-svelte-h":!0}),r(W)!=="svelte-8x81wm"&&(W.innerHTML=oe),wt=o(t),Y=a(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-fgh5wb"&&(Y.innerHTML=se),Tt=o(t),j=a(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1pe2s2l"&&(j.innerHTML=ae),bt=o(t),B=a(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-okgo5j"&&(B.innerHTML=re),xt=o(t),F=a(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1dhnlqh"&&(F.innerHTML=ue),Gt=o(t),f(A.$$.fragment,t),Mt=o(t),O=a(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-emmsc9"&&(O.textContent=me),kt=o(t),f(Z.$$.fragment,t),Ct=o(t),q=a(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-yy4ur9"&&(q.textContent=pe),Pt=o(t),N=a(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1u70yn5"&&(N.innerHTML=ge),Lt=o(t),f(z.$$.fragment,t),Ht=o(t),Q=a(t,"OL",{"data-svelte-h":!0}),r(Q)!=="svelte-1wz0fdq"&&(Q.innerHTML=fe),_t=o(t),f(V.$$.fragment,t),Et=o(t),T=a(t,"OL",{start:!0,"data-svelte-h":!0}),r(T)!=="svelte-1cndhv3"&&(T.innerHTML=ce),Ut=o(t),D=a(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1gi8bl1"&&(D.innerHTML=de),St=o(t),b=a(t,"OL",{start:!0,"data-svelte-h":!0}),r(b)!=="svelte-1wu31pe"&&(b.innerHTML=he),It=o(t),f(K.$$.fragment,t),Jt=o(t),X=a(t,"P",{"data-svelte-h":!0}),r(X)!=="svelte-ui06bn"&&(X.textContent=ye),Wt=o(t),f(R.$$.fragment,t),Yt=o(t),tt=a(t,"P",{"data-svelte-h":!0}),r(tt)!=="svelte-t1hkz2"&&(tt.innerHTML=$e),jt=o(t),f(et.$$.fragment,t),Bt=o(t),it=a(t,"P",{"data-svelte-h":!0}),r(it)!=="svelte-j4g221"&&(it.textContent=ve),Ft=o(t),f(x.$$.fragment,t),At=o(t),f(nt.$$.fragment,t),Ot=o(t),lt=a(t,"P",{}),Te(lt).forEach(i),this.h()},h(){qt(m,"name","hf:doc:metadata"),qt(m,"content",Ie),qt(T,"start","3"),qt(b,"start","4")},m(t,e){He(document.head,m),n(t,p,e),n(t,v,e),n(t,$,e),c(u,t,e),n(t,w,e),n(t,G,e),n(t,at,e),n(t,M,e),n(t,rt,e),n(t,k,e),n(t,ut,e),n(t,C,e),n(t,mt,e),n(t,P,e),n(t,pt,e),n(t,L,e),n(t,gt,e),n(t,H,e),n(t,ft,e),c(_,t,e),n(t,ct,e),n(t,E,e),n(t,dt,e),n(t,U,e),n(t,ht,e),n(t,S,e),n(t,yt,e),n(t,I,e),n(t,$t,e),n(t,J,e),n(t,vt,e),n(t,W,e),n(t,wt,e),n(t,Y,e),n(t,Tt,e),n(t,j,e),n(t,bt,e),n(t,B,e),n(t,xt,e),n(t,F,e),n(t,Gt,e),c(A,t,e),n(t,Mt,e),n(t,O,e),n(t,kt,e),c(Z,t,e),n(t,Ct,e),n(t,q,e),n(t,Pt,e),n(t,N,e),n(t,Lt,e),c(z,t,e),n(t,Ht,e),n(t,Q,e),n(t,_t,e),c(V,t,e),n(t,Et,e),n(t,T,e),n(t,Ut,e),n(t,D,e),n(t,St,e),n(t,b,e),n(t,It,e),c(K,t,e),n(t,Jt,e),n(t,X,e),n(t,Wt,e),c(R,t,e),n(t,Yt,e),n(t,tt,e),n(t,jt,e),c(et,t,e),n(t,Bt,e),n(t,it,e),n(t,Ft,e),c(x,t,e),n(t,At,e),c(nt,t,e),n(t,Ot,e),n(t,lt,e),Zt=!0},p(t,[e]){const we={};e&2&&(we.$$scope={dirty:e,ctx:t}),x.$set(we)},i(t){Zt||(d(u.$$.fragment,t),d(_.$$.fragment,t),d(A.$$.fragment,t),d(Z.$$.fragment,t),d(z.$$.fragment,t),d(V.$$.fragment,t),d(K.$$.fragment,t),d(R.$$.fragment,t),d(et.$$.fragment,t),d(x.$$.fragment,t),d(nt.$$.fragment,t),Zt=!0)},o(t){h(u.$$.fragment,t),h(_.$$.fragment,t),h(A.$$.fragment,t),h(Z.$$.fragment,t),h(z.$$.fragment,t),h(V.$$.fragment,t),h(K.$$.fragment,t),h(R.$$.fragment,t),h(et.$$.fragment,t),h(x.$$.fragment,t),h(nt.$$.fragment,t),Zt=!1},d(t){t&&(i(p),i(v),i($),i(w),i(G),i(at),i(M),i(rt),i(k),i(ut),i(C),i(mt),i(P),i(pt),i(L),i(gt),i(H),i(ft),i(ct),i(E),i(dt),i(U),i(ht),i(S),i(yt),i(I),i($t),i(J),i(vt),i(W),i(wt),i(Y),i(Tt),i(j),i(bt),i(B),i(xt),i(F),i(Gt),i(Mt),i(O),i(kt),i(Ct),i(q),i(Pt),i(N),i(Lt),i(Ht),i(Q),i(_t),i(Et),i(T),i(Ut),i(D),i(St),i(b),i(It),i(Jt),i(X),i(Wt),i(Yt),i(tt),i(jt),i(Bt),i(it),i(Ft),i(At),i(Ot),i(lt)),i(m),y(u,t),y(_,t),y(A,t),y(Z,t),y(z,t),y(V,t),y(K,t),y(R,t),y(et,t),y(x,t),y(nt,t)}}}const Ie='{"title":"Signing commits with GPG","local":"signing-commits-with-gpg","sections":[{"title":"Setting up signed commits verification","local":"setting-up-signed-commits-verification","sections":[],"depth":2},{"title":"Generating a new GPG key","local":"generating-a-new-gpg-key","sections":[],"depth":2},{"title":"Adding a GPG key to your account","local":"adding-a-gpg-key-to-your-account","sections":[],"depth":2},{"title":"Configure git to sign your commits with GPG","local":"configure-git-to-sign-your-commits-with-gpg","sections":[],"depth":2}],"depth":1}';function Je(st){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ae extends Ce{constructor(m){super(),Pe(this,m,Je,Se,Ge,{})}}export{Ae as component};
